#include "FastLED.h"

#define NUM_LEDS      60
#define LED_TYPE      WS2812
#define COLOR_ORDER   GRB
#define DATA_PIN      5
#define BUTTON_PIN    8  // Pin connected to the button

CRGBArray<NUM_LEDS> leds;

bool ledsOn = false;  // Variable to track LED state

void setup() {
  pinMode(BUTTON_PIN, INPUT_PULLUP);  // Set button pin as input with internal pull-up resistor
  delay(3000); // Safety startup delay
  FastLED.setMaxPowerInVoltsAndMilliamps(12, 4000);
  FastLED.addLeds<LED_TYPE, DATA_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection(TypicalLEDStrip);
}

void loop() {
  // Check for button press
  if (digitalRead(BUTTON_PIN) == LOW) {
    // Button is pressed
    ledsOn = !ledsOn;  // Toggle LED state
    if (ledsOn) {
      // If LEDs are turned on, display colorful effects
      showColorfulEffects();
    } else {
      // If LEDs are turned off, turn off all LEDs
      leds.fill_solid(CRGB::Black);
      FastLED.show();
    }
    // Wait for button release
    while (digitalRead(BUTTON_PIN) == LOW) {
      delay(10);
    }
  }
}

void showColorfulEffects() {
  // Your colorful effects code goes here
  // For example, you can use the code you already have for twinkling lights
  // Remember to replace 'leds' with 'leds[NUM_LEDS]' in the code below to match your array type
  // ...
  // (Your colorful effects code)
}
